'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.getHistorySection = getHistorySection;

var _projectzUtil = require('./projectz-util');

// Get History Section
function getHistorySection(data /* :Object */) /* :string */{
	// Prepare
	var link = null;
	var file = data.filenamesForReadmeFiles.history;
	if (file) {
		link = (0, _projectzUtil.getLink)({
			url: (0, _projectzUtil.getFileUrl)(data, file),
			text: 'Discover the release history by heading on over to the <code>' + file + '</code> file.'
		});
	} else if (data.github.slug) {
		link = (0, _projectzUtil.getLink)({
			url: 'https://github.com/' + data.github.slug + '/releases',
			text: 'Discover the release history by heading on over to the releases page.'
		});
	} else {
		throw new Error('History section either requires a HISTORY file or a Github repository');
	}

	// Return
	return '<h2>History</h2>\n\n' + link;
} /* @flow */